/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: shmem.c 748 2010-10-27 17:18:06Z dsl $
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "shmem.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_GET_SHM_ENTER
#define LOG_GET_SHM_ENTER(shmid, p_shmadd)
#endif /* LOG_GET_SHM_ENTER */

#ifndef LOG_GET_SHM_LEAVE
#define LOG_GET_SHM_LEAVE(ercd)
#endif /* LOG_GET_SHM_LEAVE */

/*
 *  number of shared memory regions
 */
#define tnum_shm	((uint_t)(tmax_shmid - TMIN_SHMID + 1))

/*
 *  shared memory ID to control block macros
 */
#define INDEX_SHM(shmid)	((uint_t)((shmid) - TMIN_SHMID))
#define get_shmcb(shmid)	(&(shmcb_table[INDEX_SHM(shmid)]))

/*
 *  shared memory module initialization
 */
#ifdef TOPPERS_shmini

void
initialize_shmem(void)
{
	uint_t	i;
	SHMCB	*p_shmcb;

	for (p_shmcb = shmcb_table, i = 0; i < tnum_shm; p_shmcb++, i++) {
		p_shmcb->p_shminib = &(shminib_table[i]);
	}
}

#endif /* TOPPERS_shmini */

/*
 *  get a shared memory region
 */
#ifdef TOPPERS_get_shm

ER
get_shm(ID shmid, intptr_t *p_shmadd, uint_t *p_shmsz)
{
	SHMCB	*p_shmcb;
	ER		ercd;

	LOG_GET_SHM_ENTER(shmid, p_shmadd);
	CHECK_DISPATCH();
	CHECK_SHMID(shmid);
	p_shmcb = get_shmcb(shmid);

	*p_shmadd = p_shmcb->p_shminib->shmadd;
	*p_shmsz  = p_shmcb->p_shminib->shmsz;

	ercd = E_OK;

  error_exit:
	LOG_GET_SHM_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_get_shm */
