/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: target_config.c 369 2007-07-18 12:48:50Z honda $
 */

/*
 * åȰ¸⥸塼idea6410Tѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "itron.h"
#include "mmu.h"

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint64_t idf;

/*
 * ߤγͥ٥ޥ
 */
PRI ipm;

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
uint64_t	bitpat_cfgint;

/*
 *  ٥ơ֥Ƭ
 */
extern void *vector_table;

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{

	/*
	* Initialize TZPC
	*/
	idea6410t_tzpc_init();

    /*
     *  ARM¸ν
     */
    core_initialize();

    /*
     * Initialize the TCM
     */
//     idea6410_init_tcm();

    /*
     * MMUν
     */
    idea6410_mmu_init();

    /*
     * CACHE ν
     */
    idea6410_cache_init();

    /*
     * Ƴߤγ׵ػߥե饰ػ
     */
    idf = ~0U;

    /*
     * ͥ٥ޥ0
     */
    ipm = 0U;

    /*
     * Ƥγߤޥ
     */
    tzic_disable_int(~0U);

	/*
     *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
     */
    bitpat_cfgint = 0U;

    /*
     *  sys_putc ǽˤʤ褦UART
     */
    idea6410t_init_uart();

    /*
     * ߥ٥ơ֥ VECTOR_TABLE_BASE 쥸ꤹ
     */
    CP15_SET_VBAR((uint32_t) &vector_table);
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
    /*
     *  ARM¸νλ
     */
    core_terminate();

    /*
     *  ٤Ƥγߤޥ롥
     */
    tzic_disable_int(~0U);

    /*
     *  ȯĶ¸νλ
     */
    idea6410t_exit();

    while(1);
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char_t c)
{
    if (c == '\n') {
        idea6410t_putc('\r');
    }
    idea6410t_putc(c);
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *
 * TZICϡƥ٥ȥꥬΤᡤ°ǡ
 * ȥꥬλϤǤʤ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO(intno));
    assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	bitpat_cfgint |= INTNO_BITPAT(intno);

    /*
     * äߤػߤ
     */
    x_disable_int(intno);

	/*
	 * FIQȯȤѤ
	 */
	tzic_use_fiq_gen(INTNO_BITPAT(intno));

    if ((intatr & TA_ENAINT) != 0U){
        (void)x_enable_int(intno);
    }
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void){
//     syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
