/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 267 2007-07-13 09:19:44Z honda $
 */

/*
 *  åȰ¸⥸塼 ֥ARMѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"

#define __ASSEMBLY__
#include "../../../safeg/safeg_measures.h" /* TODO: improve this */

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥          
 */

    .text
    .align 2
    .global hardware_init_hook
hardware_init_hook:
    mov   pc, lr

    .text
    .align 2
    .global fiq_handler
fiq_handler:
    /* 
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r1}  /* r0, r1٤ʤ */

    /*
     * spsrϤ뤿FIQ⡼ɤ
     */
    msr   cpsr, #(CPSR_FIQ|CPSR_CPULOCK|CPSR_ALWAYS_SET)
	mov   r0, lr
    mrs   r1, spsr

    /*
     *  FIQ⡼ɤäƤ lr_fiq, spsr_fiq  lr_irq, spsr_irq ꤹ
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
	mov   lr, r0
	msr   spsr_cxsf, r1

	msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET)
	ldmfd sp!, {r0-r1}


/*
 * ߥϥɥ
 *
 * FIQ 㳰٥ƤӽФ
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    /* 
     * IRQ⡼ɤǼ¹Ԥ
     */
    /* 
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

#ifdef SUPPORT_OVR
    stmfd sp!, {r0-r3, ip, lr}   /* save scratch registers */
    bl ovrtimer_stop             /* Х󥿥ޤ */
    ldmfd sp!, {r0-r3, ip, lr}   /* restore scratch registers */
#endif /* SUPPORT_OVR */

#if ASP_MEASURE_IRQ_LAT == 1
    perfmon_start r0
#endif

    /*
     * spsrϤ뤿IRQ⡼ɤ
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    sub   r0, lr, #4
    mrs   r1, spsr

    /*
     *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    str   r0, [sp,#0x18] /* Ϥ򥹥å */
    stmfd sp!,{r1}       /* spsr򥹥å¸ */
    mov   lr, sp         /* λΥåΤ */

    /*
     *  ¿ųߤȽ
     */
    ldr   r2, =excpt_nest_count /* 㳰ߥͥȲ */
    ldr   r3, [r2]
    add   r0,r3,#1              /* 㳰ߥͥȲ򹹿 */
    str   r0, [r2]
    cmp   r3, #0    
    bne   irq_handler_1

    /* 
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

irq_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  װȽ
     */
    ldr   r1, =TZIC0_STATUS
    ldr   r2, [r1]
	mov   r0, #31
	clz   r3, r2
	sub   r3, r0, r3

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸롥
     */
    ldr   r0, =inh_ipm_tbl      /* ͥ٤ */
    ldr   r1, [r0, r3, lsl #2]  /* r1<-ͥ   */
    ldr   r0, =ipm              /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r2, [r0]
    stmfd sp!,{r2}
    str   r1, [r0]              /* ʳͥ٥ޥ */
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤Τ¸뤿 */
    rsb   r1, r1, #0
    ldr   r2, [r0, r1, lsl #3]  /* ׵ػߥե饰 */
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */
    ldr   r0, =TZIC0_LOCK        /* å */
    ldr   lr, =TZIC_UNLOCK_CODE
    str   lr, [r0]
    ldr   r0, =TZIC0_CLEAR       /* äߤγ׵ޥ */
    mvn   lr, #0
    str   lr, [r0]
    ldr   r0, =TZIC0_ENABLE      /* ޥꤵƤʤߤε */
    orr   r1, r1, r2            /* ͤ */
    mvn   r1, r1
    str   r1, [r0]
    ldr   r0, =TZIC0_LOCK        /* å */
    ldr   lr, =TZIC_LOCK_CODE
    str   lr, [r0]

    /*
     *  ߥϥɥεưϤ
     */
    ldr   r0, =inh_tbl         /* ߥϥɥơ֥ɤ߽Ф  */
    ldr   r0, [r0,r3,lsl #2]   /* r0<-ߥϥɥ            */

    /* 
     * ߵ 
     */         
    msr   cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET)

#if SAFEG_MEASURE_FIQ_FIQ == 1
#if SAFEG_MEASURE_GPIO_ENA == 1
    gpio_clear lr, r1, GPIO_0_DATA_MASK_0  /* clear port 0 */
#endif /* SAFEG_MEASURE_GPIO_ENA */
#if SAFEG_MEASURE_PERF_ENA == 1
    perfmon_end lr, r1, r2
#endif /* SAFEG_MEASURE_PERF_ENA */
#endif /* SAFEG_MEASURE_FIQ_FIQ */

#if SAFEG_MEASURE_FIQ_IRQ == 1
#if SAFEG_MEASURE_GPIO_ENA == 1
    cmp r3, #18 /* TODO: do this general for other irqs */
    bne not_serial_irq
    gpio_set lr, r1, GPIO_0_DATA_MASK_1  /* set port 1 */
not_serial_irq:
#endif /* SAFEG_MEASURE_GPIO_ENA */
#endif /* SAFEG_MEASURE_FIQ_IRQ */

#if ASP_MEASURE_IRQ_LAT == 1
    perfmon_end lr, r1, r2
#endif

    /* 
     * ߥϥɥθƤӽФ
     */        
    ldr   lr,  =target_ret_int
    mov   pc,  r0


/*
 * åȰ¸㳰
 */
    .text
    .global target_exc_handler
target_exc_handler:    
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    str   r0, [sp,#0x18] /* Ϥ򥹥å */
    stmfd sp!,{r1}       /* spsr򥹥å¸ */    
    mov   lr, sp         /* λΥåΤ */

#ifdef SUPPORT_OVR
    stmfd sp!, {r0-r3, ip, lr}   /* save scratch registers */
    bl ovrtimer_stop             /* Х󥿥ޤ */
    ldmfd sp!, {r0-r3, ip, lr}   /* restore scratch registers */
#endif /* SUPPORT_OVR */

    ldr   r0, =ipm       /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r1, [r0]
    stmfd sp!,{r1}

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸롥
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    stmfd sp!,{r1}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     *  ¿ųߤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1,r1,#1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1    

    /* 
     * ܤμ¹Ԥʤ饹åѹ
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

target_exc_handler_1:    
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /* 
     * ȯγͥ٥ޥ򥹥å¸ 
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r0, =ipm
    ldr   r1, [r0]
    stmfd sp!,{r1}

    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0,r2,lsl #2]   /* r1<-㳰ϥɥ                 */

    /* 
     * ߵ 
     * CPUå֡ߥå֤ϷѾ
     */         
    ldr   r0, [lr]
    and   r0, r0, #(CPSR_CPULOCK)
    orr   r0, r0, #(CPSR_SVC|CPSR_ALWAYS_SET)
    msr   cpsr,r0

    /* 
     * CPU㳰ϥɥθƤӽФ
     *
     * 㳰ե졼ƬȤϤ
     */        
    mov   r0,  r3
    ldr   lr,  =target_exc_int
    mov   pc,  r1



/*
 * åȰ¸㳰ߤνи
 *
 */
    .global target_ret_int        
    .global target_exc_int        
target_ret_int:        
target_exc_int:
    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET)  

    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!,{r1}              /* γͥ٥ޥ */
    ldr   r0, =ipm              /* ͥ٥ޥ     */
    str   r1, [r0]
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤Τ¸뤿 */
    rsb   r1, r1, #0
    ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */    
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */
    ldr   r0, =TZIC0_LOCK        /* å */
    ldr   lr, =TZIC_UNLOCK_CODE 
    str   lr, [r0]
    ldr   r0, =TZIC0_CLEAR       /* äߤγ׵ޥ */
    mvn   lr, #0                
    str   lr, [r0]                                
    ldr   r0, =TZIC0_ENABLE      /* ޥꤵƤʤߤε */
    orr   r1, r1, r2            /* ͤ */    
    mvn   r1, r1                
    str   r1, [r0]
    ldr   r0, =TZIC0_LOCK        /* å */
    ldr   lr, =TZIC_LOCK_CODE 
    str   lr, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!,{r2}              /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */            
    b     ret_int
