/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: target_config.h 369 2007-07-18 12:48:50Z honda $
 */

/*
 *  åȰ¸⥸塼PB1176Tѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "pb1176t.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  SafeGѤν
 */
#ifdef TOPPERS_WITH_SAFEG

// #define TOPPERS_CUSTOM_IDLE

#endif /* TOPPERS_WITH_SAFEG */

/*
 *  CPUåǥåȤӥå
 */
#define CPSR_CPULOCK     (CPSR_FIQ_BIT|CPSR_IRQ_BIT)

/*
 *  CPSR˾˥åȤѥ
 */
#define CPSR_ALWAYS_SET  CPSR_IRQ_BIT

/*
 *  support overrun handlers (can also be enabled in CFLAGS)
 */
// #define TOPPERS_SUPPORT_OVRHDR

/*
 *  ٥롼򥫡ͥǻĤ
 */
#define VECTOR_KERNEL

/*
 *  ٥롼ʤΥ٥ɥ쥹Ƭ
 */
#define VECTOR_START  0x00

/*
 *  ǡν򤷤ʤ
 */
// #define TOPPERS_OMIT_DATA_INIT

/*
 * Use a target dependent get_utm
 */
#define OMIT_GET_UTM

/*
 *  IRQFIQϥɥץå¸ǻĤ
 *  åȰ¸ǻĤλ
 */
//#define TARGET_IRQ_HANDLER
#define TARGET_FIQ_HANDLER

/*
 *  ASPͥưΥޥåפȴϢ
 *
 *    10800000 - 1080ffff       ΰ
 *    10810000 -                ǡΰ
 *             - 11000000       ǥեȤ󥿥ƥѤΥåΰ
 */

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ      0x2000U
// TODO: check about DEFAULT_ISTK??

/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1    50
#define SIL_DLY_TIM2    40

/*
 *  ߥϥɥֹ˴ؤ
 */
#define TMIN_INHNO 0U
#define TMAX_INHNO 31U
#define TNUM_INH   32U

/*
 *  ֹ˴ؤ
 */
#define TMIN_INTNO 0U
#define TMAX_INTNO 31U
#define TNUM_INT   32U


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֹϰϤȽ
 *
 *  ӥåȥѥΤưפˤ뤿ˡ8Ϸ֤ˤʤäƤ롥
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)   VALID_INTNO(intno)

/*
 *  ߥϥɥϿѥơ֥
 *   ֤ϥե졼
 */
extern const FP inh_tbl[TNUM_INH];

/*
 *  ߥϥɥ
 */
Inline void
x_define_inh(INHNO inhno, FP inthdr)
{
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 *  TOPPERSɸ߽ǥμ¸
 */

/*
 *  ߤΥϥɥγͥ٥ơ֥
 *
 *  TZICϳߥϥɥװͥ٤Ǥʤᡤեȥ
 *  Ū˼¸
 */
extern const PRI inh_ipm_tbl[TNUM_INH];

/*
 *  Ƴߤγ׵ػߥե饰ξ
 */
extern uint32_t idf;

/*
 *  ͥ٥ޥ饤֥
 *
 *  CM922Tϳͥ٥ޥϡɥŪ˻ʤᡤ
 *  ׵ػߥե饰ˤͥ٥ޥ¸
 */

/*
 *  ߤγͥ٥ޥ
 */
extern PRI ipm;

/*
 *  ͥ٥ޥ˥åȤ롤׵ػߥե饰
 *  Υơ֥
 */
extern const uint32_t ipm_mask_tbl[(TMAX_INTPRI - TMIN_INTPRI + 1)];

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  IPMimp_mask_tblΥǥåѴޥ
 */
#define INDEX_IPM(ipm)  (-(ipm)-1)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (ǥ)ͥ٥ޥ
 *
 *  ꤵ줿ͥ٤ꤵ줿׵ػߥե饰Υơ֥ͤȡʥ
 *  Ρ˳Ƴߤγ׵ػߥե饰ξ֤ݻѿͤȤ
 *  ORIRCγ׵ػߥե饰˥åȤꤷͥ٤ѿ
 *  ipm¸롥
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint32_t ipm_mask;

    if (intpri == TIPM_ENAALL) {
        ipm_mask = 0U;
    } else {
        ipm_mask = ipm_mask_tbl[INDEX_IPM(intpri)];
    }

    /*
     *  CM922Tγߥȥϥ֥͡쥸
     *  ꥢ쥸뤿ᡤöƤγߤػߤƤ顤
     *  γߤΤߵĤɬפ
     */
    /* ߶ػ */
    tzic_disable_int(~0U);

    /* ޥꤵƤʤߤΤߵ */
    tzic_enable_int(~(ipm_mask|idf));

    ipm = intpri;
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  ipm֤ͤ
 */
Inline PRI
x_get_ipm(void)
{
    return(ipm);
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
extern uint32_t	bitpat_cfgint;

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥ޤʥǥΡ˳׵ػߥե饰idf
 *  ӥåȤ򥻥åȤ롥
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
#define SUPPORT_DIS_INT /* dis_int򥵥ݡȤ */

Inline bool_t
x_disable_int(INTNO intno)
{
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }
    tzic_disable_int(INTNO_BITPAT(intno));
    idf |= INTNO_BITPAT(intno);
    return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/*
 *  (ǥ)׵ػߥե饰β
 *
 *  ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 *  Ĥ롥ޤʥǥΡ˳׵ػߥե饰idf
 *  ӥåȤ򥯥ꥢ롥
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
#define SUPPORT_ENA_INT /* ena_int򥵥ݡȤ */

Inline bool_t
x_enable_int(INTNO intno)
{
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }
    tzic_enable_int(INTNO_BITPAT(intno));
    idf &= ~INTNO_BITPAT(intno);
    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *  ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
    tzic_clear_int(INTNO_BITPAT(intno));
}

#define t_clear_int(intno) x_clear_int(intno)
#define i_clear_int(intno) x_clear_int(intno)


/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
    return(tzic_probe_int(INTNO_BITPAT(intno)));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 *
 *  TZICϡƥ٥ȥꥬΤᡤ°ǡȥꥬλϤǤ
 *  ʤ
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 *
 *  CM922TǤϡɬפʽϤʤ
 */
Inline void
i_begin_int(INTNO intno)
{
}

/*
 *  ߥϥɥνиɬפIRC
 *
 *  TZICǤϡɬפʽϤʤ
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

/*
 *  atexitνȥǥȥ饯μ¹
 */
Inline void
call_atexit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }
}

/*
 *  ߥϥɥtarget_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);


#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_config.h"

/*
 *  ȥ졼˴ؤ
 */
// #include "nulltrace/trace_config.h"

#endif /* TOPPERS_TARGET_CONFIG_H */
