/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: target_ovrtimer.h 264 2009-11-17 08:23:10Z dsl $
 */

/*
 *		Х󥿥ޥɥ饤СPB1176ѡ
 */

#ifndef TOPPERS_TARGET_OVRTIMER_H
#define TOPPERS_TARGET_OVRTIMER_H

#include <sil.h>
#include "pb1176t.h"
#include "target_config.h"

/*
 *  Х󥿥޳ߥϥɥϿΤ
 */
#define INHNO_OVRTIMER	IRQNO_OVRTIMER		/* ߥϥɥֹ */
#define INTNO_OVRTIMER	IRQNO_OVRTIMER		/* ֹ */
#define INTPRI_OVRTIMER	-5					/* ͥ */
#define INTATR_OVRTIMER	0					/* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽη
 */
typedef ulong_t		OVRCLOCK;

/*
 *  ͤɽȥץå֤ȤѴ
 *
 *  PB1176Ǥϡޤ1˥ȥåפ롥
 */
#define TO_OVRCLOCK(ovrtim)		((ulong_t)(ovrtim))
#define TO_OVRTIM(clk)			((OVRTIM)(clk))

/*
 *  Х󥿥ޤν
 *
 *  Х󥿥ޤνԤޤưϤϹԤʤ
 *  ߥϥɥϿϡtarget_ovrtimer.cfg򥳥ե졼˽
 *  뤳ȤǹԤ
 */
Inline void
target_ovrtimer_initialize(void)
{
	sil_wrw_mem((void *)(OVRTIMER_BASE_REG + TIMER_SP804_1CONTROL),
		OVRTIMER_SP804_CONTROL_BITS);

	sil_wrw_mem((void *)(OVRTIMER_BASE_REG + TIMER_SP804_1CLEAR), 0x01);
}

/*
 *  Х󥿥ޤư
 *
 *  Х󥿥ޤˡĤovrtimꤷưϤ롥ovrtim
 *  ñ̤ϦäȤ롥
 */
Inline void
target_ovrtimer_start(OVRTIM ovrtim)
{
	assert(ovrtim > 0u);
	assert(ovrtim <= TMAX_OVRTIM);

	sil_wrw_mem((void *)(OVRTIMER_BASE_REG + TIMER_SP804_1LOAD),
		TO_OVRCLOCK(ovrtim));

	sil_wrw_mem((void *)(OVRTIMER_BASE_REG + TIMER_SP804_1CONTROL),
		OVRTIMER_SP804_CONTROL_BITS | OVRTIMER_SP804_CONTROL_ENA);
}

/*
 *  Х󥿥ޤλĤ֤μ
 *
 *  Х󥿥ޤλĤ֤ɤ߽Ф
 */
Inline OVRTIM
target_ovrtimer_get_current(void)
{
	return(TO_OVRTIM(
		sil_rew_mem((void *)(OVRTIMER_BASE_REG + TIMER_SP804_1VALUE))));
}

/*
 *  Х󥿥ޤ
 *
 *  Х󥿥ޤߤޤλĤ֤ɤ߽Ф⤷Ĥ
 *  0ʤޤϤ̤ˤˤʤäƤˤϡ1֤ޤХ
 *  󥿥ޤγߤ򥯥ꥢ롥
 */
Inline OVRTIM
target_ovrtimer_stop(void)
{
	OVRCLOCK cyc;

	sil_wrw_mem((void *)(OVRTIMER_BASE_REG + TIMER_SP804_1CONTROL),
		OVRTIMER_SP804_CONTROL_BITS);

	cyc = sil_rew_mem((void *)(OVRTIMER_BASE_REG + TIMER_SP804_1VALUE));

	return TO_OVRTIM(cyc);
}

/*
 *  Х󥿥޳ߥϥɥ
 */
extern void	target_overtimer_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_OVRTIMER_H */
