#ifndef _SAFEG_H_
#define _SAFEG_H_

/* IRQ */
#define IRQ_COUNT    0x000FFFF8
/* FIQ */
#define FIQ_COUNT    0x000FFFFC

/*
 * irq, fiq 뤿δؿ
 * tz_basic.S  irq, fiq ϥɥǸƤФ.
 * δؿ˹Ԥ򵭽Ҥ.
 */

// #define ENABLE_FIQ_MANAGEMENT
// #define ENABLE_IRQ_MANAGEMENT

#ifdef ENABLE_IRQ_MANAGEMENT
void irq_management(void);
#endif

#ifdef ENABLE_FIQ_MANAGEMENT
void fiq_management(void);
#endif

struct NtContextSavedAreaStruct
{
    unsigned long n_usr_r0;
    unsigned long n_usr_r1;
    unsigned long n_usr_r2;
    unsigned long n_usr_r3;
    unsigned long n_usr_r4;
    unsigned long n_usr_r5;
    unsigned long n_usr_r6;
    unsigned long n_usr_r7;
    unsigned long n_usr_r8;
    unsigned long n_usr_r9;
    unsigned long n_usr_r10;
    unsigned long n_usr_r11;
    unsigned long n_usr_r12;
    unsigned long n_usr_sp;
    unsigned long n_usr_lr;
    unsigned long n_pc;
    unsigned long n_cpsr;
    unsigned long n_scratch;
    unsigned long n_irq_spsr;
    unsigned long n_irq_sp;
    unsigned long n_irq_lr;
    unsigned long n_svc_spsr;
    unsigned long n_svc_sp;
    unsigned long n_svc_lr;
    unsigned long n_abt_spsr;
    unsigned long n_abt_sp;
    unsigned long n_abt_lr;
    unsigned long n_und_spsr;
    unsigned long n_und_sp;
    unsigned long n_und_lr;
    unsigned long n_fiq_spsr;
    unsigned long n_fiq_r8;
    unsigned long n_fiq_r9;
    unsigned long n_fiq_r10;
    unsigned long n_fiq_r11;
    unsigned long n_fiq_r12;
    unsigned long n_fiq_sp;
    unsigned long n_fiq_lr;
};
struct TContextSavedAreaStruct
{
    unsigned long s_usr_r0;
    unsigned long s_usr_r1;
    unsigned long s_usr_r2;
    unsigned long s_usr_r3;
    unsigned long s_usr_r4;
    unsigned long s_usr_r5;
    unsigned long s_usr_r6;
    unsigned long s_usr_r7;
    unsigned long s_usr_r8;
    unsigned long s_usr_r9;
    unsigned long s_usr_r10;
    unsigned long s_usr_r11;
    unsigned long s_usr_r12;
    unsigned long s_usr_sp;
    unsigned long s_usr_lr;
    unsigned long s_pc;
    unsigned long s_cpsr;
    unsigned long s_scratch;
    unsigned long s_irq_spsr;
    unsigned long s_irq_sp;
    unsigned long s_irq_lr;
    unsigned long s_svc_spsr;
    unsigned long s_svc_sp;
    unsigned long s_svc_lr;
    unsigned long s_abt_spsr;
    unsigned long s_abt_sp;
    unsigned long s_abt_lr;
    unsigned long s_und_spsr;
    unsigned long s_und_sp;
    unsigned long s_und_lr;
    unsigned long s_fiq_spsr;
    unsigned long s_fiq_r8;
    unsigned long s_fiq_r9;
    unsigned long s_fiq_r10;
    unsigned long s_fiq_r11;
    unsigned long s_fiq_r12;
    unsigned long s_fiq_sp;
    unsigned long s_fiq_lr;
};
#endif
